import "./style.css";
import { reactive as L, ref as w, watchEffect as N, onActivated as j, nextTick as x, onBeforeUnmount as B, resolveComponent as m, openBlock as D, createElementBlock as I, createElementVNode as c, createVNode as p, withCtx as T, withDirectives as F, vShow as O, pushScopeId as W, popScopeId as A } from "vue";
import { Button as P } from "@opentiny/vue";
import { VueMonaco as U, CloseIcon as V, LinkButton as H } from "@opentiny/tiny-engine-common";
import { useModal as J, useCanvas as S, useNotify as z, useHelp as R } from "@opentiny/tiny-engine-controller";
import { initCompletion as Y } from "@opentiny/tiny-engine-common/js/completion";
import { lint as q, initLinter as G } from "@opentiny/tiny-engine-common/js/linter";
import { theme as K } from "@opentiny/tiny-engine-controller/adapter";
import { insertName as Q, string2Ast as b, formatString as X, ast2String as Z } from "@opentiny/tiny-engine-common/js/ast";
import { constants as $ } from "@opentiny/tiny-engine-utils";
import { getSchema as M } from "@opentiny/tiny-engine-canvas";
import { isFunction as tt } from "@opentiny/vue-renderless/grid/static";
const { SCHEMA_DATA_TYPE: et } = $, { message: ot, confirm: nt } = J(), s = L({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null
}), l = w(null);
let h = null;
const f = () => {
  var e;
  const t = ((e = M) == null ? void 0 : e()) || {};
  return t.methods = (t == null ? void 0 : t.methods) || {}, t.methods;
}, st = () => S().pageState.pageSchema && Object.keys(f()) || [], C = () => {
  const e = Object.entries(f()).map(([o, n]) => Q(o, n.value)).join(`
`);
  return h = b(e), e;
}, rt = (t) => {
  if (s.isChanged = t !== s.script, !l.value)
    return;
  const e = l.value.getEditor().getModel();
  q(e, s.linterWorker);
}, y = ({ name: t, content: e }) => {
  if (!t)
    return;
  const o = f();
  o[t] || (o[t] = {
    type: et.JSFunction,
    value: ""
  }), o[t].value = e;
}, E = () => {
  if (!s.isChanged)
    return !1;
  if (s.hasError)
    return ot({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存"
    }), !1;
  const t = l.value.getEditor().getValue(), e = b(t);
  return M().methods = {}, e.program.body.forEach((o, n) => {
    var a, d;
    const r = (a = o == null ? void 0 : o.id) == null ? void 0 : a.name;
    (d = e.program.body[n + 1]) != null && d.leadingComments && o.trailingComments === e.program.body[n + 1].leadingComments && delete o.trailingComments;
    const i = X(Z(o).trim(), "javascript");
    y({ name: r, content: i });
  }), S().setSaved(!1), s.isChanged = !1, z({
    type: "success",
    message: "保存成功！"
  }), !0;
}, it = (t) => (e) => {
  const o = tt(e) ? e : () => t("close");
  if (!s.isChanged) {
    o(!0);
    return;
  }
  nt({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      o(E());
    },
    cancel() {
      o(!0);
    }
  });
}, ct = () => {
  if (!s.editorSelection || !l.value)
    return;
  const t = l.value.getEditor();
  t.setSelection(s.editorSelection), t.focus();
  const e = t.getTopForLineNumber(s.editorSelection.startLineNumber - 1);
  t.setScrollPosition(
    {
      scrollLeft: 0,
      scrollTop: e
    },
    0
  );
}, lt = (t) => {
  var n;
  if (!t)
    return;
  const e = h == null ? void 0 : h.program.body.filter((r) => {
    var i;
    return t === ((i = r == null ? void 0 : r.id) == null ? void 0 : i.name);
  });
  if (e.length === 0)
    return;
  const o = (n = e[0]) == null ? void 0 : n.loc;
  o && (s.editorSelection = {
    startColumn: o.start.column,
    startLineNumber: o.start.line,
    endColumn: o.end.column + 1,
    endLineNumber: o.end.line
  }), s.editorSelection && ct();
}, at = ({ emit: t }) => (N(() => {
  s.script = C();
}), j(() => {
  x(() => {
    var e;
    s.script = C(), (e = l.value) == null || e.focus(), window.dispatchEvent(new Event("resize"));
  });
}), {
  state: s,
  monaco: l,
  change: rt,
  saveMethods: E,
  close: it(t)
});
const dt = (t, e) => {
  const o = t.__vccOpts || t;
  for (const [n, r] of e)
    o[n] = r;
  return o;
}, ut = {
  saveMethod: y,
  highlightMethod: lt,
  getMethodNameList: st,
  getMethods: f
}, mt = {
  components: {
    MonacoEditor: U,
    TinyButton: P,
    CloseIcon: V,
    LinkButton: H
  },
  emits: ["close"],
  setup(t, { emit: e }) {
    const o = R().getDocsUrl("script"), { state: n, monaco: r, change: i, close: a, saveMethods: d } = at({ emit: e }), g = {
      roundedSelection: !0,
      automaticLayout: !0,
      autoIndent: !0,
      language: "javascript",
      formatOnPaste: !0,
      tabSize: 2,
      theme: K(),
      minimap: {
        enabled: !1
      },
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0
    }, _ = (u) => {
      r.value && (Y(r.value.getMonaco()), n.linterWorker = G(u, r.value.getMonaco(), n));
    };
    return B(() => {
      var u, v;
      (v = (u = n.linterWorker) == null ? void 0 : u.terminate) == null || v.call(u);
    }), {
      state: n,
      monaco: r,
      options: g,
      close: a,
      change: i,
      saveMethods: d,
      editorDidMount: _,
      docsUrl: o
    };
  }
}, k = (t) => (W("data-v-55b53bc5"), t = t(), A(), t), pt = { class: "plugin-page-js-container" }, ht = { class: "code-edit-head" }, ft = { class: "head-left" }, gt = /* @__PURE__ */ k(() => /* @__PURE__ */ c("span", { class: "title" }, "页面 JS", -1)), _t = { class: "head-right" }, vt = /* @__PURE__ */ k(() => /* @__PURE__ */ c("span", null, "保存", -1)), Ct = { class: "dots" }, St = { class: "code-edit-content" };
function bt(t, e, o, n, r, i) {
  const a = m("link-button"), d = m("tiny-button"), g = m("close-icon"), _ = m("monaco-editor");
  return D(), I("div", pt, [
    c("div", ht, [
      c("div", ft, [
        gt,
        p(a, { href: n.docsUrl }, null, 8, ["href"])
      ]),
      c("div", _t, [
        p(d, {
          type: "primary",
          class: "save-btn",
          onClick: n.saveMethods
        }, {
          default: T(() => [
            vt,
            F(c("span", Ct, null, 512), [
              [O, n.state.isChanged]
            ])
          ]),
          _: 1
        }, 8, ["onClick"]),
        p(g, { onClose: n.close }, null, 8, ["onClose"])
      ])
    ]),
    c("div", St, [
      p(_, {
        ref: "monaco",
        value: n.state.script,
        options: n.options,
        onChange: n.change,
        onEditorDidMount: n.editorDidMount
      }, null, 8, ["value", "options", "onChange", "onEditorDidMount"])
    ])
  ]);
}
const Mt = /* @__PURE__ */ dt(mt, [["render", bt], ["__scopeId", "data-v-55b53bc5"]]), Ft = {
  id: "PageController",
  title: "页面 JS",
  icon: "plugin-icon-js",
  align: "top",
  api: ut,
  component: Mt,
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
};
export {
  Ft as default
};
